Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 1679)
@@ -2203,55 +2260,29 @@
       if FLastCollTime <> '' then
         begin
-          calCollTime.Text := ValidCollTime(FLastColltime);
+          calCollTime.Text := ValidColltime(FLastColltime);
           if IsFMDateTime(calCollTime.Text) then
             begin
               calCollTime.Text := FormatFMDateTime('mmm dd,yy@hh:nn', StrToFMDateTime(calColltime.Text));
-              calColltime.FMDateTime := StrToFMDateTime(FLastCollTime);
+              calCollTime.FMDateTime := StrToFMDateTime(FLastCollTime);
             end;
         end
       else if tmpORECALLTime <> '' then
         begin
-          calCollTime.Text := ValidCollTime(tmpORECALLTime);
+          calCollTime.Text := ValidColltime(tmpORECALLTime);
           if IsFMDateTime(calCollTime.Text) then
             begin
               calCollTime.Text := FormatFMDateTime('mmm dd,yy@hh:nn', StrToFMDateTime(calColltime.Text));
-              calColltime.FMDateTime := StrToFMDateTime(tmpORECALLTime);
+              calCollTime.FMDateTime := StrToFMDateTime(tmpORECALLTime);
             end;
         end
       else if LRFDATE <> '' then
         calCollTime.Text     := LRFDATE
-      else
-        calCollTime.Text     := 'TODAY';
-    end
-  else if CollType = 'WC' then
-    begin
-      cboColltime.Visible    := False;
-      txtImmedColl.Visible   := False;
-      pnlCollTimeButton.Visible   := False;
-      pnlCollTimeButton.TabStop := False;
-      calCollTime.Visible    := True;
-      calColltime.Enabled    := True;
-      if FLastCollTime <> '' then
-        begin
-          calCollTime.Text := ValidColltime(FLastColltime);
-          if IsFMDateTime(calCollTime.Text) then
-            begin
-              calCollTime.Text := FormatFMDateTime('mmm dd,yy@hh:nn', StrToFMDateTime(calColltime.Text));
-              calColltime.FMDateTime := StrToFMDateTime(FLastCollTime);
-            end;
-        end
-      else if tmpORECALLTime <> '' then
-        begin
-          calCollTime.Text := ValidColltime(tmpORECALLTime);
-          if IsFMDateTime(calCollTime.Text) then
-            begin
-              calCollTime.Text := FormatFMDateTime('mmm dd,yy@hh:nn', StrToFMDateTime(calColltime.Text));
-              calColltime.FMDateTime := StrToFMDateTime(tmpORECALLTime);
-            end;
-        end
-      else if LRFDATE <> '' then
-        calCollTime.Text     := LRFDATE
-      else
+      else if not(FOrderAction in [ORDER_EDIT]) then
         calCollTime.Text     := 'NOW';
+      if (havetest = false) and (RemoveCollTimeDefault = True) then
+        begin
+          calCollTime.Text := '';
+          calCollTime.FMDateTime := 0;
+        end;
     end
   else if CollType = 'LC' then
@@ -2274,4 +2305,8 @@
       else
         cboCollTime.ItemIndex := 0;
+      if (havetest = false) and (RemoveCollTimeDefault = True) then
+        begin
+          cboCollTime.Text := '';
+        end;
     end
   else if CollType = 'I' then
@@ -2279,5 +2314,5 @@
       cboColltime.Visible    := False;
       calCollTime.Visible    := False;
-      calColltime.Enabled    := False;
+      calCollTime.Enabled    := False;
       txtImmedColl.Visible   := True;
       pnlCollTimeButton.Visible   := True;
@@ -2291,5 +2326,4 @@
       else if LRFDATE <> '' then
         tmpTime := StrToFMDateTime(LRFDATE);
-
       if tmpTime > tmpImmTime then
         begin
@@ -2301,4 +2335,10 @@
           calCollTime.FMDateTime := GetDefaultImmCollTime;
           txtImmedColl.Text      := FormatFMDateTime('mmm dd,yy@hh:nn', calCollTime.FMDateTime);
+        end;
+      if (havetest = false) and (RemoveCollTimeDefault = True) then
+        begin
+          calCollTime.Text := '';
+          calCollTime.FMDateTime := 0;
+          txtImmedColl.Text := '';
         end;
     end;
@@ -2387,4 +2427,5 @@
 begin
   inherited;
+  cboReasons.Text := StringReplace(cboReasons.Text,CRLF,'  ',[rfReplaceAll]);
   if (length(cboReasons.Text) > 75) then
     begin
@@ -2414,22 +2455,25 @@
 var
   i: integer;
-  text : string;
   ListItem: TListItem;
-  aCollTime,aTypeScreen,aStr,aModifier,aSpecimen,aTestYes,x,aName,aTNSString: string;
+  aCollTime,aTypeScreen,aStr,aModifier,aSpecimen,aSpecimenUID,aSpecimenReq,aTestYes,x,aName,aTNSString, aUrgText: string;
   aList: TStringList;
-  curAdd,AnInstance,aTNS,aTNSDays: Integer;
+  curAdd,aTNS: Integer;
   sub,sub1: string;
-  AResponse: TResponse;
+  aChanging: Boolean;
 begin
   if cboAvailTest.ItemID = '' then Exit;
   aList := TStringList.Create;
+  aChanging := changing;
   try
     ALabTest := nil;
     aTypeScreen := '';
-    aSpecimen := '^';
+    aSpecimen := '';
+    aSpecimenUID := '';
+    aSpecimenReq := '';
     aTestYes := '1';
     aModifier := '';
     changing := true;
     tQuantity.Text := '';
+    changing := aChanging;
     sub1 := '';
     cboModifiers.ItemIndex := -1;
@@ -2439,24 +2483,14 @@
     ALabTest := TLabTest.Create(cboAvailTest.ItemID, Responses);
     sub := GetSubtype(ALabTest.TestName);
-    with CtrlInits do
-        begin
-          SetControl(cboCollType, 'Collection Types');
-          LoadCollType(cboCollType);
-          if FLastCollType <> '' then
-            cboCollType.SelectByID(FLastCollType)
-          else if uDfltCollType <> '' then
-            cboCollType.SelectByID(uDfltCollType)
-          else if OrderForInpatient then
-            if (ALabTest.LabCanCollect) then
-              cboCollType.SelectByID('LC')
-            else
-              cboCollType.SelectByID('WC')
-          else
-            cboCollType.SelectByID('SP');
-          SetupCollTimes(cboCollType.ItemID);
-        end;
+    {if not(FOrderAction in [ORDER_COPY, ORDER_EDIT, ORDER_QUICK]) then
+      DetermineCollectionDefaults(Responses); }
+    DetermineCollectionDefaults(Responses);
     with cboAvailTest do
       begin
-        if (Length(ItemID) = 0) or (ItemID = '0') then Exit;
+        if (Length(ItemID) = 0) or (ItemID = '0') then
+          begin
+            changing := aChanging;
+            Exit;
+          end;
         FLastLabID := ItemID ;
         FLastItemID := ItemID;
@@ -2467,13 +2501,12 @@
               lvSelectionList.Items[i].Selected := true;
               lvSelectionListClick(self);
+              changing := aChanging;
               Exit;
             end;
-        Changing := True;
-        Changing := False;
         ExtractTypeScreen(aList, uVBECList);
         if aList.Count > 0 then aTypeScreen := aList[0];
         aList.Clear;
         aTNSString := '';
-        if (StrToInt(aTypeScreen) = cboAvailTest.ItemID) and (uTNSOrders.Count > 0) then
+        if (Changing = false) and (StrToInt(aTypeScreen) = cboAvailTest.ItemID) and (uTNSOrders.Count > 0) then
           begin
             for i := 0 to uTNSOrders.Count - 1 do
@@ -2482,12 +2515,11 @@
               begin
                 NormalizeTopMosts;
-                aTNSDays := TNSDaysBack;
                 aTNS :=
                   MessageBox(PChar(aTNSString + CRLF + CRLF +
-                             'Do you wish to continue?'),
-                             PChar('Type & Screen Entered in Past ' + IntToStr(TNSDaysBack) + ' Days'),
-                             MB_YESNO);
+                   'Do you wish to cancel this request for Type & Screen?'),
+                   PChar('Type & Screen Entered in Past ' + IntToStr(TNSDaysBack) + ' Days'),
+                   MB_YESNO);
                 RestoreTopMosts;
-                if aTNS = 7 then
+                if aTNS = 6 then
                   begin
                     cboAvailTest.ItemIndex := -1;
@@ -2515,22 +2547,26 @@
               end;
         end;
-        Changing := False;
       end;
     if LRORDERMODE = TORDER_MODE_DIAG then
       begin
         if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
-        with cboCollType do if Length(ItemID) > 0 then
+        if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text)
+        else if changing = false then
           begin
-            Responses.Update('COLLECT', 1, ItemID, ItemID) ;
-            FLastCollType := ItemID;
-          end;
-        if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text)
-        else
-          begin
-            cboUrgency.ItemIndex := 1;
+            for i := 0 to cboUrgency.Items.Count - 1 do
+              begin
+                aUrgText := cboUrgency.Items[i];
+                if aUrgText = '9^ROUTINE' then    // Find urgency default of ROUTINE
+                  begin
+                    cboUrgency.ItemIndex := i;
+                    break;
+                  end;
+              end;
             Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
           end;
         if Length(memDiagComment.Text) > 0 then Responses.Update('COMMENT',1,memDiagComment.Text,memDiagComment.Text);
         if Length(cboReasons.Text) > 0 then Responses.Update('REASON',1,cboReasons.Text,cboReasons.Text);
+        with cboCollTime do
+
         if cboCollType.ItemID = 'LC' then
           begin
@@ -2547,21 +2583,20 @@
                 end;
           end
-          else
-            begin
-              with calCollTime do
-                if FMDateTime > 0 then
-                  begin
-                    Responses.Update('START', 1, ValidCollTime(Text), Text);
-                    FLastColltime := ValidCollTime(Text);
-                  end
-                else
-                  begin
-                    Responses.Update('START', 1, '', '') ;
-                    FLastCollTime := '';
-                  end;
-            end;
-          if Length(cboCollType.Text) > 0 then Responses.Update('COLLECT',1,cboCollType.ItemID,cboCollType.ItemID);
+        else
+          begin
+            with calCollTime do
+              if FMDateTime > 0 then
+                begin
+                  Responses.Update('START', 1, ValidCollTime(Text), Text);
+                  FLastColltime := ValidCollTime(Text);
+                end
+              else
+                begin
+                  Responses.Update('START', 1, '', '') ;
+                  FLastCollTime := '';
+                end;
+          end;
+        if Length(cboCollType.Text) > 0 then Responses.Update('COLLECT',1,cboCollType.ItemID,cboCollType.ItemID);
       end;
-    if length(cboCollTime.ItemID) > 0 then aCollTime := cboCollTime.Items[cboCollTime.ItemIndex];
     uTestSelected := true;
     with lvSelectionList do
@@ -2583,5 +2618,5 @@
           end;
       end;
-    aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + aCollTime + '^' + cboCollType.Text + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces
+    aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimenReq + '^' + aSpecimen + '^' + aSpecimenUID + '^' + IntToStr(aLabTest.ItemID);
     uSelectedItems.Add(aStr);
     CurAdd := 1;
@@ -2600,6 +2635,4 @@
     aList.Free;
   end;
-  edtResults.Height := 247;
-  edtInfo.Height := 247;
   if lvSelectionList.Items.Count > 0 then
     begin
@@ -2618,7 +2651,7 @@
   aMSBOS,aMSBOSContinue,curAdd,AnInstance: integer;
   sub,sub1: string;
-  AResponse: TResponse;
   ListItem: TListItem;
-  aTypeScreen,aSpecimen,aTestYes,aStr,aMsg,aModifier,x,x1,aReason,aSurgery,aCollTime,aCollSave,aName: String;
+  aTypeScreen,aSpecimen,aSpecimenUID,aSpecimenReq,aTestYes,aStr,aMsg,aModifier,x,x1,aReason,aSurgery,aCollTime,aCollSave,aName,aUrgText: String;
+  aChanging: Boolean;
 begin
   if cboAvailComp.ItemID = '' then Exit;
@@ -2626,4 +2659,5 @@
   aTests := TStringList.Create;
   sub1 := '';
+  aChanging := changing;
   try
     DisableDiagTestControls;
@@ -2634,5 +2668,5 @@
         tQuantity.Text := '';
         cboModifiers.ItemIndex := -1;
-        changing := false;
+        changing := aChanging;
       end;
     LRORDERMODE := TORDER_MODE_COMP;
@@ -2652,12 +2686,11 @@
         ALabTest := TLabTest.Create(ItemID, Responses);
         sub := GetSubtype(ALabTest.TestName);
-        Changing := False;
+        changing := aChanging;
         StatusText('');
       end;
-    //Check for and display any associated Lab Results
     aList.Clear;
     TestAdded := 0;
     getTest := 0;
-    ExtractTests(aList, uVBECList);   //Get Results associated with ordered components
+    ExtractTests(aList, uVBECList);   //Get Lab Results associated with ordered components
       for j := 0 to aList.Count - 1 do
         begin
@@ -2683,11 +2716,14 @@
       if TestAdded = 1 then
         begin
-          edtResults.Clear;
           aTests.Clear;
           GetPatientBloodResults(aTests, Patient.DFN, uTestsForResults);
-          QuickCopy(ATests,edtResults);
-          if edtResults.Lines.Count > 0 then TabResults.Caption := 'Lab Results Available';
-          uRaw.Clear;
-          GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
+          if aTests.Count > 0 then
+            begin
+              edtResults.Clear;
+              QuickCopy(ATests,edtResults);
+              TabResults.Caption := 'Lab Results Available';
+              uRaw.Clear;
+              GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
+            end;
         end;
       CurAdd := 1;
@@ -2699,5 +2735,7 @@
         end;
     aTypeScreen := '';
-    aSpecimen := '^';
+    aSpecimen := '';
+    aSpecimenUID := '';
+    aSpecimenReq := '';
     aTestYes := '0';
     aReason := '';
@@ -2709,11 +2747,27 @@
     aList.Clear;
     ExtractSpecimen(aList, uVBECList);
-    if aList.Count > 0 then aSpecimen := aList[0];
+    if aList.Count > 0 then
+      begin
+        aSpecimen := piece(aList[0], '^', 1);
+        aSpecimenUID := piece(aList[0], '^', 2);
+      end;
+    if (cboSurgery.ItemID = '') and (length(cboSurgery.Text) > 0) then
+      begin
+        for i := 0 to cboSurgery.Items.Count - 1 do
+          if uppercase(cboSurgery.Text) = uppercase(piece(cboSurgery.Items[i],'^',2)) then
+            begin
+              cboSurgery.ItemIndex := i;
+              Break;
+            end;
+      end;
     if length(cboModifiers.ItemID) > 0 then aModifier := cboModifiers.Items[cboModifiers.ItemIndex];
     if length(cboReasons.ItemID) > 0 then aReason := cboReasons.Items[cboReasons.ItemIndex];
     if length(cboSurgery.ItemID) > 0 then aSurgery := cboSurgery.Items[cboSurgery.ItemIndex];
-    if length(cboCollTime.ItemID) > 0 then aCollTime := cboCollTime.Items[cboCollTime.ItemIndex];
-    if Length(cboSurgery.ItemID) > 0 then
-      begin
+    if (Length(cboSurgery.ItemID) > 0) and (length(tQuantity.Text) > 0) and (strToInt(tQuantity.Text) > 0) then
+      begin
+        uChangingMSBOS := true;
+        cboSurgeryChange(self);
+        uChangingMSBOS := false;
+        if cboAvailComp.ItemIndex = -1 then Exit;
         aList.Clear;
         ExtractMSBOS(aList, uVBECList);    //Get maximum units for selected Surgey
@@ -2721,5 +2775,5 @@
           begin
             if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
-             and (piece(aList[i],'^',3) = cboSurgery.Text) then
+             and (uppercase((piece(aList[i],'^',3))) = uppercase(cboSurgery.Text)) then
               begin
                 aMSBOS := StrToInt(piece(aList[i],'^',4));
@@ -2731,13 +2785,15 @@
                       aMSBOSContinue :=
                         MessageBox(PChar('The number of units ordered (' + tQuantity.Text +
-                                   ') for ' + aLabTest.TestName + ' exceeds the maximum number of units ('
-                                   + IntToStr(aMSBOS) +
-                                   ') for the ' + cboSurgery.text +
-                                   ' surgical procedure selected.' + CRLF + CRLF + 'Do you wish to continue?'),
-                                   PChar('Maximum Number of Units Exceeded'),
-                                   MB_YESNO);
+                         ') for ' + aLabTest.TestName + ' Exceeds the maximum number recommended ('
+                         + IntToStr(aMSBOS) +
+                         ') for the ' + cboSurgery.text +
+                         ' surgical procedure.' + CRLF +
+                         'If you need to order more than the maximum number of units, please enter a justification in the Comment box.'
+                          + CRLF + CRLF + 'Edit the Blood component Quantity?'),
+                         PChar('Maximum Number of Units Exceeded'),
+                         MB_YESNO);
                       RestoreTopMosts;
                     end;
-                    if aMSBOSContinue = 7 then
+                    if aMSBOSContinue = 6 then
                       begin
                         ShowMsg(cboAvailComp.Text + ' has NOT been added to this request.');
@@ -2748,5 +2804,5 @@
           end;
       end;
-    if (uTNSOrders.Count < 1) then // SpecimenNeeded(aList, uVBECList, aLabTest.ItemID) then  //check to see if type and screen is needed
+    if (uTNSOrders.Count < 1) and (SpecimenNeeded(aList, uVBECList, aLabTest.ItemID)) then  //check to see if type and screen is needed CQ 17349
       begin
         uGetTnS := 1;
@@ -2772,5 +2828,7 @@
         if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID) then
           begin
-            aSpecimen := piece(aList[i],'^',2) + '^' + aSpecimen;
+            aSpecimenReq := piece(aList[i],'^',2);
+            if (SpecimenNeeded(aList, uVBECList, aLabTest.ItemID)) then
+              aSpecimenUID := '';
             break;
           end;
@@ -2794,5 +2852,5 @@
         ListItem.SubItems.Add(piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',1));
       end;
-      aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces additional pieces added for Tests
+      aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimenReq + '^' + aSpecimen + '^' + aSpecimenUID + '^' + IntToStr(aLabTest.ItemID);
       uSelectedItems.Add(aStr);
       CurAdd := 1;
@@ -2816,5 +2874,14 @@
                 else
                   begin
-                    cboUrgency.ItemIndex := 1;
+                    cboUrgency.ItemIndex := 2;
+                    for j := 0 to cboUrgency.Items.Count - 1 do
+                      begin
+                        aUrgText := cboUrgency.Items[j];
+                        if aUrgText = '9^ROUTINE' then    // Find urgency default of ROUTINE
+                          begin
+                            cboUrgency.ItemIndex := i;
+                            break;
+                          end;
+                      end;
                     Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
                   end;
@@ -2836,51 +2903,6 @@
       pnlMessage.Visible := true;
       pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
-    end;
-  {if uGetTnS = 1 then
-    begin
-      if responses.QuickOrder < 1 then
-        begin
-          for i := 1 to cboAvailTest.Items.Count - 1 do
-            begin
-              if piece(cboAvailTest.Items[i],'^',1) = aTypeScreen then
-                begin
-                  if piece(aSpecimen,'^',1) = '1' then
-                    begin
-                      cboCollTime.Text := calWantTime.Text;
-                      aCollSave := cboCollTime.Text + '^' + cboCollTime.ItemID + '^' + cboCollType.Text + '^' + cboCollType.ItemID;
-                      cboCollTime.Text := '';
-                      cboCollType.Text := '';
-                      uSpecimen := 1;
-                    end;
-                  cboModifiers.Text := '';
-                  cboAvailTest.SelectByID(aTypeScreen);
-                  cboTests.SelectByID(aTypeScreen);
-                  cboTestsClick(self);
-                  //cboAvailTestSelect(Self);
-                  uSpecimen := 0;
-                  cboCollTime.Text := piece(aCollSave,'^',1);
-                  cboCollType.Text := piece(aCollSave,'^',3);
-                  aCollSave := '';
-                  break;
-                end;
-            end;
-          aMsg := 'An order for Type and Screen has been added to this request' + '.';
-        end
-        else
-          begin
-            lblTNS.Caption := 'TYPE + SCREEN must be added to order';
-            lblTNS.Visible := true;
-            memMessage.Text := 'TYPE + SCREEN must be added to order';
-            memMessage.Visible := false;
-            pnlMessage.Visible := true;
-          end;
-      end;
-  if (uGetTnS = 1) then
-    begin
-      if length(aMsg) > 0 then aMsg := aMsg + crlf + crlf;
-      ShowMsg(aMsg);
-    end;  }
-  edtResults.Height := 247;
-  edtInfo.Height := 247;
+    end
+    else pnlDiagnosticTests.Caption := 'Diagnostic Tests';
   if lvSelectionList.Items.Count > 0 then
     begin
@@ -2899,4 +2921,6 @@
 
 procedure TfrmODBBank.DisableComponentControls;
+var
+  j: integer;
 begin
   lblQuantity.Enabled := false;
@@ -2904,5 +2928,17 @@
   lblModifiers.Enabled := false;
   cboModifiers.Enabled := false;
+  lblQuantity.Caption := 'Quantity';
+  lblWanted.Caption := 'Date/Time Wanted';
+  lblReason.Caption := 'Reason for Request';
   cboAvailComp.ItemIndex := -1;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if piece(uSelectedItems[j],'^',1) = '0' then
+        begin
+          lblReason.Caption := 'Reason for Request*';
+          lblWanted.Caption := 'Date/Time Wanted*';
+          Break;
+        end;
+    end;
 end;
 
@@ -2913,4 +2949,7 @@
   lblModifiers.Enabled := true;
   cboModifiers.Enabled := true;
+  lblQuantity.Caption := 'Quantity*';
+  lblWanted.Caption := 'Date/Time Wanted*';
+  lblReason.Caption := 'Reason for Request*';
   if not(changing) then
     if not(uSelUrgency = 'PRE-OP') then
@@ -2919,28 +2958,65 @@
           cboUrgency.SelectByID(IntToStr(uDfltUrgency));
   if cboUrgency.Text = 'PRE-OP' then
-    begin
-      lblSurgery.Enabled := true;
-      cboSurgery.Enabled := true;
-      lblSurgery.Caption := 'Surgery*';
-    end
-    else
-      begin
-        lblSurgery.Enabled := false;
-        cboSurgery.Enabled := false;
-        lblSurgery.Caption := 'Surgery';
-      end;
+        begin
+          lblSurgery.Enabled := true;
+          cboSurgery.Enabled := true;
+          lblSurgery.Caption := 'Surgery*';
+        end
+      else
+        begin
+          if Length(cboSurgery.Text) > 0 then
+            begin
+              lblSurgery.Enabled := true;
+              cboSurgery.Enabled := true;
+              lblSurgery.Caption := 'Surgery*';
+            end
+            else
+            begin
+              lblSurgery.Enabled := false;
+              cboSurgery.Enabled := false;
+              lblSurgery.Caption := 'Surgery';
+              cboSurgery.ItemIndex := -1;
+              Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
+            end;
+        end;
+
   lblDiagComment.Enabled := true;
 end;
 
 procedure TfrmODBBank.DisableDiagTestControls;
-begin
-  lblCollTime.Enabled := false;
-  calCollTime.Enabled := false;
-  cboCollTime.Enabled := false;
-  lblCollType.Enabled := false;
-  cboCollType.Enabled := false;
-  cmdImmedColl.Enabled := false;
+var
+  i,j: integer;
+  diagflg: boolean;
+begin
+  diagflg := false;
+  for i := 0 to uSelectedItems.Count - 1 do
+    begin
+      if (piece(uSelectedItems[i],'^',1) = '1') then
+        begin
+          diagflg := true;
+          Break;
+        end;
+    end;
+  if diagflg = false then
+    begin
+      lblCollTime.Enabled := false;
+      calCollTime.Enabled := false;
+      cboCollTime.Enabled := false;
+      lblCollType.Enabled := false;
+      cboCollType.Enabled := false;
+      cmdImmedColl.Enabled := false;
+    end;
+  lblCollTime.Caption := 'Collection Date/Time';
+  lblCollType.Caption := 'Collection Type';
   cboAvailTest.ItemIndex := -1;
-  cboAvailTest.InitLongList('');
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if piece(uSelectedItems[j],'^',1) = '1' then
+        begin
+          lblCollTime.Caption := 'Collection Date/Time*';
+          lblCollType.Caption := 'Collection Type*';
+          Break;
+        end;
+    end;
 end;
 
@@ -2953,4 +3029,6 @@
   cboCollType.Enabled := true;
   cmdImmedColl.Enabled := true;
+  lblCollTime.Caption := 'Collection Date/Time*';
+  lblCollType.Caption := 'Collection Type*';
   if not(changing) then
     if not(uSelUrgency = 'PRE-OP') then
@@ -2971,7 +3049,4 @@
 begin
   if ALabTest = nil then exit;
-  if ALabTest.LabSubscript = 'BB' then exit;
-  calCollTime.Clear;
-  cboCollTime.Clear;
   calCollTime.Enabled := True;
   lblCollTime.Enabled := True;
@@ -3024,5 +3099,12 @@
               begin
                 calCollTime.Enabled := False;
-                if RespStart <> nil then txtImmedColl.Text := RespStart.EValue;
+                cboCollType.SelectByID('I');
+                SetupCollTimes('I');
+                //cboCollTypeClick(self);
+                //txtImmedColl.Enabled := True;
+                if RespStart <> nil then
+                  begin
+                    txtImmedColl.Text := RespStart.EValue;
+                  end;
               end;
         end
@@ -3032,19 +3114,50 @@
 end;
 
+procedure TfrmODBBank.cboAvailTestEnter(Sender: TObject);
+var
+  j: integer;
+begin
+  inherited;
+  if Length(cboAvailTest.Text) > 0 then Exit;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '1') then
+        begin
+          lvSelectionList.Items[j].Selected := true;
+          lvSelectionListClick(self);
+          Break;
+        end;
+    end;
+end;
+
 procedure TfrmODBBank.cboAvailTestExit(Sender: TObject);
 begin
   inherited;
-  if (Length(cboAvailTest.ItemID) = 0) or (cboAvailTest.ItemID = '0') then Exit;
+  if (Length(cboAvailTest.Text)>0) and (Length(cboAvailTest.ItemID) = 0) or (cboAvailTest.ItemID = '0') then
+    begin
+      ShowMsg('Invalid Test Selection. Please select a valid Test.');
+      cboAvailTestSelect(cboAvailTest);
+      cboAvailTest.SetFocus;
+      Exit;
+    end;
   if cboAvailTest.ItemID = FLastLabID then Exit;
-  cboAvailTestSelect(cboAvailTest);
-  cboAvailTest.SetFocus;
-  PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
-end;
-
-procedure TfrmODBBank.cboAvailCompChange(Sender: TObject);
-begin
-  inherited;
-  changing := true;
-  changing := false;
+  if not (Length(cboAvailTest.ItemID) = 0) then cboAvailTestSelect(cboAvailTest);
+end;
+
+procedure TfrmODBBank.cboAvailCompEnter(Sender: TObject);
+var
+  j: integer;
+begin
+  inherited;
+  if Length(cboAvailComp.Text) > 0 then Exit;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '0') then
+        begin
+          lvSelectionList.Items[j].Selected := true;
+          lvSelectionListClick(self);
+          Break;
+        end;
+    end;
 end;
 
@@ -3052,9 +3165,13 @@
 begin
   inherited;
-  if (Length(cboAvailComp.ItemID) = 0) or (cboAvailComp.ItemID = '0') then Exit;
+  if (Length(cboAvailComp.Text)>0) and (Length(cboAvailComp.ItemID) = 0) or (cboAvailComp.ItemID = '0') then
+    begin
+      ShowMsg('Invalid Component selection. Please select a valid Component.');
+      cboAvailCompSelect(cboAvailComp);
+      cboAvailComp.SetFocus;
+      Exit;
+    end;
   if cboAvailComp.ItemID = FLastLabID then Exit;
-  cboAvailCompSelect(cboAvailComp);
-  cboAvailComp.SetFocus;
-  PostMessage(Handle, WM_NEXTDLGCTL, 0, 0);
+  if not (Length(cboAvailComp.ItemID) = 0) then cboAvailCompSelect(cboAvailComp);
 end;
 
@@ -3130,4 +3247,40 @@
 end;
 
+procedure TfrmODBBank.pnlBloodComponentsClick(Sender: TObject);
+begin
+  inherited;
+  cboAvailComp.SetFocus;
+end;
+
+procedure TfrmODBBank.pnlBloodComponentsEnter(Sender: TObject);
+begin
+  inherited;
+  pnlBloodComponents.Color := clActiveborder;
+end;
+
+procedure TfrmODBBank.pnlBloodComponentsExit(Sender: TObject);
+begin
+  inherited;
+  pnlBloodcomponents.Color := clBtnFace;
+end;
+
+procedure TfrmODBBank.pnlDiagnosticTestsClick(Sender: TObject);
+begin
+  inherited;
+  cboAvailTest.SetFocus;
+end;
+
+procedure TfrmODBBank.pnlDiagnosticTestsEnter(Sender: TObject);
+begin
+  inherited;
+  pnlDiagnosticTests.Color := clActiveBorder;
+end;
+
+procedure TfrmODBBank.pnlDiagnosticTestsExit(Sender: TObject);
+begin
+  inherited;
+  pnlDiagnosticTests.Color := clBtnFace;
+end;
+
 procedure TfrmODBBank.cboCollTimeChange(Sender: TObject);
 var
@@ -3163,4 +3316,21 @@
 end;
 
+procedure TfrmODBBank.cboCollTimeEnter(Sender: TObject);
+var
+  j: integer;
+begin
+  inherited;
+  if Length(cboAvailTest.Text) > 0 then Exit;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '1') then
+        begin
+          lvSelectionList.Items[j].Selected := true;
+          lvSelectionListClick(self);
+          Break;
+        end;
+    end;
+end;
+
 procedure TfrmODBBank.cboCollTypeChange(Sender: TObject);
 begin
@@ -3180,6 +3350,28 @@
   SetupCollTimes(cboCollType.ItemID);
   if Length(cboCollType.Text) > 0 then Responses.Update('COLLECT',1,cboCollType.ItemID,cboCollType.ItemID);
-  FLastCollType := cboCollType.ItemID;
   calCollTimeChange(self);
+end;
+
+procedure TfrmODBBank.cboCollTypeClick(Sender: TObject);
+begin
+  inherited;
+  FOrderAction := 0;
+end;
+
+procedure TfrmODBBank.cboCollTypeEnter(Sender: TObject);
+var
+  j: integer;
+begin
+  inherited;
+  if Length(cboAvailTest.Text) > 0 then Exit;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '1') then
+        begin
+          lvSelectionList.Items[j].Selected := true;
+          lvSelectionListClick(self);
+          Break;
+        end;
+    end;
 end;
 
@@ -3226,4 +3418,21 @@
 end;
 
+procedure TfrmODBBank.cboModifiersEnter(Sender: TObject);
+var
+  j: integer;
+begin
+  inherited;
+  if Length(cboAvailComp.Text) > 0 then Exit;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '0') then
+        begin
+          lvSelectionList.Items[j].Selected := true;
+          lvSelectionListClick(self);
+          Break;
+        end;
+    end;
+end;
+
 procedure TfrmODBBank.LoadModifiers(AComboBox:TORComboBox);
 var
@@ -3257,9 +3466,11 @@
     begin
       Clear;
-      for i := 0 to uUrgencyList.Count - 1 do
+      {for i := 0 to uUrgencyList.Count - 1 do
          if (piece(uUrgencyList[i],'^',2) = 'STAT') and (StatAllowed(Patient.DFN) = false) then
            Continue
          else
-           Items.Add(uUrgencyList[i]);
+           Items.Add(uUrgencyList[i]); }
+      for i := 0 to uUrgencyList.Count - 1 do
+        Items.Add(uUrgencyList[i]);
     end;
 end;
@@ -3281,8 +3492,8 @@
   if cboCollType.ItemID = 'LC' then
     begin
-      if FLastLabCollTime <> '' then
+      if (FLastLabCollTime <> '') and (length(cboCollTime.Text) < 1) then
         cboCollTime.SelectByID(piece(FLastLabCollTime,'^',1));
     end
-  else
+  else if length(calcollTime.Text) < 1 then
     begin
       if FLastCollTime = 'TODAY' then
@@ -3293,5 +3504,5 @@
         calCollTime.Text := FormatFMDateTime('mmm dd,yyyy@hh:nn',StrToFMDateTime(FLastCollTime));
     end;
-  if FLastCollType <> '' then
+  if (FLastCollType <> '') and (length(cboCollType.Text) < 1) then
     cboCollType.SelectByID(FLastCollType);
   if uSelectedItems.Count > 0 then
